#include <stdio.h>
#include <string.h>

#define NMAX 250001

int v[NMAX], c[NMAX], p[NMAX];
int i, j, N, teste;
long long sc[NMAX];

int main() {
	freopen("zlego.in", "r", stdin);
    freopen("zlego.out", "w", stdout);
  scanf("%d", &teste);

  while (teste--) {
    scanf("%d", &N);
    for (i = 1; i <= N; i++)
      scanf("%d", &v[i]);
    for (i = 1; i <= N; i++)
      scanf("%d", &c[i]);
    
    // functia prefix de la KMP
    p[1] = j = 0;
    for (i = 2; i <= N; i++) {
      while (v[j + 1] != v[i] && j > 0)
        j = p[j];
      if (v[j + 1] == v[i])
        j++;
      p[i] = j;
    }
    
    memset(sc, 0, sizeof(sc));
    for (i = N; i >= 1; i--) {
      sc[i] += c[i];
      sc[p[i]] += sc[i];
    }
    
    // afisare
    for (i = 1; i <= N; i++)
      printf("%lld\n", sc[i]);
  }

	return 0;
}
