/* Andrei Parvu
   O(N^2) */

#include <cstdio>

const int NMAX = 250000;

int sir[NMAX + 5], cost[NMAX + 5], n, pi[NMAX + 5], teste;

void prefix() {
  int x = 0, i;

  for (i = 2; i <= n; i ++) {
    for (; x > 0 && sir[i] != sir[x + 1]; x = pi[x]);

    if (sir[i] == sir[x + 1]) {
      x ++;
    }

    pi[i] = x;
  }
}


int main() {
  freopen("zlego.in", "rt", stdin);
  freopen("zlego.out", "wt", stdout);

  scanf("%d", &teste);

  for (; teste--; ) {
    scanf("%d", &n);

    for (int i = 1; i <= n; i ++) {
      scanf("%d", sir + i);
    }

    for (int i = 1; i <= n; i ++) {
      scanf("%d", cost + i);
    }

    prefix();

    for (int i = 1; i <= n; i ++) {
      int x = 0;
      long long suma = 0;

      for (int j = 1; j <= n; j ++) {
        for (; x > 0 && (sir[j] != sir[x + 1]|| x + 1 > i); ) {
          x = pi[x];
        }

        if (sir[j] == sir[x + 1]) {
          x ++;
        }

        if (x == i) {
          suma += cost[j];
        }
      }

      printf("%lld\n", suma);
    }
  }

  return 0;
}

