/*
 * (C) 2012 Bogdan-Cristian Tătăroiu
 */
#include <cstdio>
#include <cstring>
#include <cassert>

using namespace std;

const int MAXN = 250000;
int N, x[MAXN], p[MAXN], c[MAXN];
long long sum[MAXN];

int main() {
    assert(freopen("zlego.in", "rt", stdin));
    assert(freopen("zlego.out", "wt", stdout));

    int T;
    assert(scanf("%d", &T) == 1);
    for (; T; T--) {
        assert(scanf("%d", &N) == 1);
        assert(1 <= N && N <= MAXN);
        for (int i = 0; i < N; i++) {
            assert(scanf("%d", x + i) == 1);
        }
        for (int i = 0; i < N; i++) {
            assert(scanf("%d", c + i) == 1);
        }

        memset(sum, 0, sizeof(sum));

        p[0] = -1;
        for (int i = 1; i < N; i++) {
            for (p[i] = p[i - 1]; p[i] >= 0 && x[i] != x[p[i] + 1]; p[i] = p[p[i]]);
            if (x[i] == x[p[i] + 1]) {
                p[i] += 1;
            }
        }

        for (int i = N - 1; i >= 0; i--) {
            if (p[i] == -1) {
                continue;
            }
            sum[p[i]] += sum[i] + c[i];
        }

        for (int i = 0; i < N; i++) {
            printf("%lld\n", sum[i] + c[i]);
        }
    }
    return 0;
}
