/* Andrei Parvu
   O(N^3) */

#include <cstdio>

const int NMAX = 250000;

int sir[NMAX + 5], cost[NMAX + 5], n, teste;

int main() {
  freopen("zlego.in", "rt", stdin);
  freopen("zlego.out", "wt", stdout);

  scanf("%d", &teste);

  for (; teste--; ) {
    scanf("%d", &n);

    for (int i = 1; i <= n; i ++) {
      scanf("%d", sir + i);
    }

    for (int i = 1; i <= n; i ++) {
      scanf("%d", cost + i);
    }

    for (int i = 1; i <= n; i ++) {
      long long suma = 0;

      for (int j = 1; j <= n - i + 1; j ++) {
        bool prost = false;

        for (int k = 1; k <= i; k ++) {
          if (sir[k] != sir[j + k - 1]) {
            prost = true;
            break;
          }
        }

        if (!prost) {
          suma += cost[j + i - 1];
        }
      }

      printf("%lld\n", suma);
    }
  }

  return 0;
}

