#include <stdio.h>

#define NMAX 250001

int v[NMAX], c[NMAX], p[NMAX];
int i, j, N;

int main() {
	freopen("zlego.in", "r", stdin);
    freopen("zlego.out", "w", stdout);
  int teste;

  scanf("%d", &teste);

  while (teste--) {
    scanf("%d", &N);
    for (i = 1; i <= N; i++)
      scanf("%d", &v[i]);
    for (i = 1; i <= N; i++)
      scanf("%d", &c[i]);
    
    // functia prefix de la KMP
    p[1] = j = 0;
    for (i = 2; i <= N; i++) {
      while (v[j + 1] != v[i] && j > 0)
        j = p[j];
      if (v[j + 1] == v[i])
        j++;
      p[i] = j;
    }

    long long sc[NMAX] = {0};

    for (i = 1; i <= N; i++) {
      sc[i] = c[i];
      j = p[i];
      while (j > 0) {
        sc[j] += c[i];
        j = p[j];
      }
    }
    
    // afisare
    for (i = 1; i <= N; i++)
      printf("%lld\n", sc[i]);
  }

	return 0;
}
